<?php

namespace Litepci\Sampleset\Repositories\Presenter;

use League\Fractal\TransformerAbstract;
use Hashids;

class SamplesetTransformer extends TransformerAbstract
{
    public function transform(\Litepci\Sampleset\Models\Sampleset $sampleset)
    {
        return [
            'id'                => $sampleset->getRouteKey(),
            'key'               => [
                'public'    => $sampleset->getPublicKey(),
                'route'     => $sampleset->getRouteKey(),
            ], 
            'id'                => $sampleset->id,
            'name'              => $sampleset->name,
            'slug'              => $sampleset->slug,
            'user_id'           => $sampleset->user_id,
            'user_type'         => $sampleset->user_type,
            'created_at'        => $sampleset->created_at,
            'updated_at'        => $sampleset->updated_at,
            'deleted_at'        => $sampleset->deleted_at,
            'url'               => [
                'public'    => trans_url('sampleset/'.$sampleset->getPublicKey()),
                'user'      => guard_url('sampleset/sampleset/'.$sampleset->getRouteKey()),
            ], 
            'status'            => trans('app.'.$sampleset->status),
            'created_at'        => format_date($sampleset->created_at),
            'updated_at'        => format_date($sampleset->updated_at),
        ];
    }
}